<template id="post-edit">
    <div>
        <h3>Edit Article</h3>
        <form v-on:submit.prevent="updateArticle">
            <div class="form-group">
                <label for="edit-title">Title *</label>
                <input id="edit-title" v-model="article.title" class="form-control"/>
            </div>
            <div class="form-group">
                <label>Body *</label>
                <textarea class="form-control" rows="10" v-model="article.body"></textarea>
            </div>
            <div v-if="errors.length && errors.length > 0" class="form-group">
                <div class="alert alert-danger">
                    <p><b>Please correct the following error(s):</b></p>
                    <ul>
                        <li v-for="error in errors">{{ error }}</li>
                    </ul>
                </div>
            </div>
            <div class="text-right">
                <button type="submit" class="btn btn-primary">Save</button>
                <router-link class="btn btn-warning" v-bind:to="'/'">Cancel</router-link>
            </div>
        </form>
    </div>
</template>

<script>
  export default {
    data: function () {
      return {
        article: {
          id: '',
          title: '',
          body: ''
        },
        errors: [],
      }
    },
    created: function () {
      fetch('/api/article/' + this.$route.params.id)
        .then(res => res.json())
        .then(res => {
          this.article = res.data;
          this.article.article_id = this.$route.params.id;
        });
    },
    methods: {
      updateArticle() {
        this.errors = [];
        // Check Validate
        if (!this.article.title) {
          this.errors.push('Title is required');
        }

        if (!this.article.body) {
          this.errors.push('Body is required');
        }

        if (this.errors.length > 0) {
          return false;
        }

        // Update
        fetch('/api/article', {
          method: 'put',
          body: JSON.stringify(this.article),
          headers: {
            'content-type': 'application/json'
          }
        })
          .then(res => res.json())
          .then(data => {
            alert('Article Updated');
          })
          .catch(err => console.log(err));
      }
    }
  }
</script>